﻿using Aquaforest.Office.PDF;
using Aquaforest.PDF;
using System;
using System.IO;

namespace OfficeToPDFConversion
{
    internal class OfficeConversion
    {
        private static void Main(string[] args)
        {
            //Assign Licence Key
            PDFToolkit.LicenseKey = "MD1TdGFuZGFyZCBEZXZlbG9wZXI7MT10cmlhbDsyPTUyNDc3NzQ2NTM5ODM5Mjc4ODk7Mz10cmlhbDs0PTE7NT1UcnVlOzUuMT1GYWxzZTsxMD0xNDs4PTE1RTgzRUY4NkY4QkI4N0I5MjBDN0IwMDQxN0M2RDY5RTQ2NDlGRTUzNDE1MUYwQTg0MjQ2NzhEMDUyNEY5Q0U7OT0yLjEuMC4w";
            string wordInput = @"..\documents\source\Skills.docx";
            string excelInput = @"..\documents\source\excel.xlsx";
            string powerPointInput = @"..\documents\source\split.pptx";
            string pubInput = @"..\documents\source\publisher.pub";
            string wordOutput = @"..\documents\output\word.pdf";
            string excelOutput = @"..\documents\output\excel.pdf";
            string powerPointOutput = @"..\documents\output\powerpoint.pdf";
            string pubOutput = @"..\documents\output\pub.pdf";
            DocumentSettings docSettings = new DocumentSettings { BookmarkOption = AquaforestPDFBookmarks.BOOKMARKS_FROM_HEADINGS, PDFA1a = true };
            ConvertWordToPDF(wordInput, wordOutput, docSettings);
            ConvertExcelToPDF(excelInput, excelOutput, docSettings);
            ConvertPowerPointToPDF(powerPointInput, powerPointOutput, docSettings);
            ConvertPublisherToPDF(pubInput, pubOutput, docSettings);
        }

        public static void ConvertWordToPDF(string input, string output, DocumentSettings settings)
        {
            try
            {
                WordToPDF wordToPDF = new WordToPDF(Path.GetFullPath(input));
                wordToPDF.ConvertToPDF(settings, Path.GetFullPath(output));
            }
            catch (Exception)
            {
            }
        }

        public static void ConvertExcelToPDF(string input, string output, DocumentSettings settings)
        {
            try
            {
                ExcelToPDF wordToPDF = new ExcelToPDF(Path.GetFullPath(input));
                wordToPDF.ConvertToPDF(settings, Path.GetFullPath(output));
            }
            catch (Exception)
            {
            }
        }

        public static void ConvertPowerPointToPDF(string input, string output, DocumentSettings settings)
        {
            try
            {
                PowerPointToPDF wordToPDF = new PowerPointToPDF(Path.GetFullPath(input));
                settings.OptimizeFor = 0;
                wordToPDF.DocStructureTags = true;
                wordToPDF.FrameSlides = true;
                wordToPDF.PowerPointHandoutOrder = 0;
                wordToPDF.ConvertToPDF(settings, Path.GetFullPath(output));
            }
            catch (Exception)
            {
            }
        }

        public static void ConvertPublisherToPDF(string input, string output, DocumentSettings settings)
        {
            try
            {
                PublisherToPDF wordToPDF = new PublisherToPDF(Path.GetFullPath(input));
                wordToPDF.ConvertToPDF(settings, Path.GetFullPath(output));
            }
            catch (Exception)
            {
            }
        }
    }
}