﻿using Aquaforest.PDF;
using System;

namespace PDFAConversionAndValidation
{
    internal class PdfaOperations
    {
        private static void Main(string[] args)
        {
            //Assign Licence Key
            PDFToolkit.LicenseKey = "MD1TdGFuZGFyZCBEZXZlbG9wZXI7MT10cmlhbDsyPTUyNDc3NzQ2NTM5ODM5Mjc4ODk7Mz10cmlhbDs0PTE7NT1UcnVlOzUuMT1GYWxzZTsxMD0xNDs4PTE1RTgzRUY4NkY4QkI4N0I5MjBDN0IwMDQxN0M2RDY5RTQ2NDlGRTUzNDE1MUYwQTg0MjQ2NzhEMDUyNEY5Q0U7OT0yLjEuMC4w";
            string inputFile = @"..\documents\source\image_pdf.pdf";
            string outputFile = @"..\documents\output\pdfa.pdf";

            //Converting PDF File to PDF
            ConvertToPDFA(inputFile, outputFile, AquaforestPDFAFlavour.PDFA_1_B);

            //Validate PDFa File
            PDFAValidationResult results = ValidatePDFA(AquaforestPDFAFlavour.PDFA_1_B, outputFile);

            //check the result
            if (results.IsValid)
            {
                //Success
                Console.WriteLine("Validated!");
            }
            else
            {
                //Not validated, print out validation errors
                foreach (var error in results.ValidationResult)
                {
                    Console.WriteLine(error);
                }
            }
        }

        public static void ConvertToPDFA(string input, string output, AquaforestPDFAFlavour flavour)
        {
            try
            {
                //Create PDFA object
                PDF2PDFaConverter pdfaConverter = new PDF2PDFaConverter(input, output, flavour);
                //Convert File to PDFa
                pdfaConverter.ConvertToPDFA();
            }
            catch (Exception e)
            {
            }
        }

        public static PDFAValidationResult ValidatePDFA(AquaforestPDFAFlavour flavour, string file)
        {
            try
            {
                //Create PDFAValidator object
                PDFAValidator pdfaValidator = new PDFAValidator();
                // Validate file base on flavour
                return pdfaValidator.ValidatePDFA(file, flavour);
            }
            catch (Exception)
            {
                return null;
            }
        }
    }
}