﻿using Aquaforest.PDF;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;

namespace PDFToolkitCMD
{
    internal class ToolkitCMD
    {
        private static Arguments CommandLine = null;
        private static PDFToolkitArguements toolkitArgs = null;
        internal static List<string> ValidOperations = null;
        private static string originalOutPut = string.Empty;

        public static string ReplaceIgnoreCase(string original, string oldValue, string newValue)
        {
            return Regex.Replace(original, oldValue, newValue, RegexOptions.IgnoreCase);
        }

        private static void Main(string[] args)
        {
            PDFToolkit.LicenseKey = GetLicenseKey();
            toolkitArgs = new PDFToolkitArguements();
            CommandLine = new Arguments(args);
            GetParamerters();
            ValidateCommmand();
            ProcessSource();
        }

        private static void GetParamerters()
        {
            string s = "";

            //Bate Length
            s = GetStringParameter("BateLength");
            if (s != null)
            {
                try
                {
                    toolkitArgs.BateLength = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Bate Length: " + s);
                }
            }
            s = GetStringParameter("StartNumber");
            if (s != null)
            {
                try
                {
                    toolkitArgs.StartNumber = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    toolkitArgs.StartNumber = 1;
                    Console.WriteLine("Start Number: " + s);
                }
            }
            else
            {
                toolkitArgs.StartNumber = 1;
            }
            s = GetStringParameter("BottomMargin");
            if (s != null)
            {
                try
                {
                    toolkitArgs.BottomMargin = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Bottom Margin: " + s);
                }
            }
            else
            {
                toolkitArgs.BottomMargin = 5;
            }
            s = GetStringParameter("CellMargin");
            if (s != null)
            {
                try
                {
                    toolkitArgs.CellMargin = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Cell Margin: " + s);
                }
            }
            else
            {
                toolkitArgs.CellMargin = 5;
            }
            s = GetStringParameter("EndPage");
            if (s != null)
            {
                try
                {
                    toolkitArgs.EndPage = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("End Page: " + s);
                }
            }
            s = GetStringParameter("Font");
            if (s != null)
            {
                toolkitArgs.Font = s;
            }
            s = GetStringParameter("FontSize");
            if (s != null)
            {
                try
                {
                    toolkitArgs.FontSize = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Font Size: " + s);
                }
            }
            s = GetStringParameter("LeftMargin");
            if (s != null)
            {
                try
                {
                    toolkitArgs.LeftMargin = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Left Margin: " + s);
                }
            }
            else
            {
                toolkitArgs.LeftMargin = 5;
            }
            s = GetStringParameter("PageHeight");
            if (s != null)
            {
                try
                {
                    toolkitArgs.PageHeight = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Page Height: " + s);
                }
            }
            s = GetStringParameter("PageWidth");
            if (s != null)
            {
                try
                {
                    toolkitArgs.PageWidth = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Page Width: " + s);
                }
            }
            s = GetStringParameter("Length");
            if (s != null)
            {
                try
                {
                    toolkitArgs.Length = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Length: " + s);
                }
            }
            s = GetStringParameter("Metadata");
            if (s != null)
            {
                toolkitArgs.Metadata = s;
            }
            s = GetStringParameter("OnErrorContinue");
            if (s != null)
            {
                if (s.ToLower() != "false")
                {
                    toolkitArgs.OnErrorContinue = true;
                }
                else
                {
                    toolkitArgs.OnErrorContinue = false;
                }
            }

            s = GetStringParameter("CreateFolders");
            if (s != null)
            {
                if (s.ToLower() != "false")
                {
                    toolkitArgs.CreateFolders = true;
                }
                else
                {
                    toolkitArgs.CreateFolders = false;
                }
            }
            s = GetStringParameter("Overwrite");
            if (s != null)
            {
                if (s.ToLower() != "false")
                {
                    toolkitArgs.Overwrite = true;
                }
                else
                {
                    toolkitArgs.Overwrite = false;
                }
            }
            s = GetStringParameter("Opacity");
            if (s != null)
            {
                try
                {
                    toolkitArgs.Opacity = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Opacity: " + s);
                }
            }
            s = GetStringParameter("OpenSettings");
            if (s != null)
            {
                toolkitArgs.OpenSettings = s;
            }
            s = GetStringParameter("PDFAVersion");
            if (s != null)
            {
                toolkitArgs.PDFAVersion = s;
            }
            s = GetStringParameter("Operation");
            if (s != null)
            {
                toolkitArgs.Operation = s;
            }
            else
            {
                Console.WriteLine("Sorry the Operation parameter is empty, please provide a valid Operation ");
                Usage();
            }
            s = GetStringParameter("MergeWildCards");
            if (s != null)
            {
                toolkitArgs.MergeWildCards = s;
            }
            s = GetStringParameter("OutputFile");
            if (s != null)
            {
                toolkitArgs.OutputFile = s;
            }
            s = GetStringParameter("XmpFile");
            if (s != null)
            {
                toolkitArgs.XmpFile = Path.GetFullPath(s);
            }

            s = GetStringParameter("Overlay");
            if (s != null)
            {
                toolkitArgs.Overlay = s;
            }

            s = GetStringParameter("PageNumber");
            if (s != null)
            {
                try
                {
                    toolkitArgs.PageNumber = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Page Number: " + s);
                }
            }
            else
            {
                toolkitArgs.PageNumber = -1;
            }

            s = GetStringParameter("Password");
            if (s != null)
            {
                toolkitArgs.Password = s;
            }

            s = GetStringParameter("UserPassword");
            if (s != null)
            {
                toolkitArgs.UserPassword = s;
            }

            s = GetStringParameter("OwnerPassword");
            if (s != null)
            {
                toolkitArgs.OwnerPassword = s;
            }

            s = GetStringParameter("Pdfa");
            if (s != null)
            {
                if (s.ToLower() != "false")
                {
                    toolkitArgs.Pdfa = true;
                }
                else
                {
                    toolkitArgs.Pdfa = false;
                }
            }
            s = GetStringParameter("IncludeProperty");
            if (s != null)
            {
                if (s.ToLower() != "false")
                {
                    toolkitArgs.IncludeProperty = true;
                }
                else
                {
                    toolkitArgs.IncludeProperty = false;
                }
            }
            s = GetStringParameter("ConvertBookmark");
            if (s != null)
            {
                if (s.ToLower() != "false")
                {
                    toolkitArgs.ConvertBookmark = true;
                }
                else
                {
                    toolkitArgs.ConvertBookmark = false;
                }
            }
            s = GetStringParameter("EmbedFont");
            if (s != null)
            {
                if (s.ToLower() != "false")
                {
                    toolkitArgs.EmbedFont = true;
                }
                else
                {
                    toolkitArgs.EmbedFont = false;
                }
            }
            s = GetStringParameter("Permissions");
            if (s != null)
            {
                toolkitArgs.Permissions = s;
            }

            s = GetStringParameter("RepeatingRange");
            if (s != null)
            {
                try
                {
                    toolkitArgs.RepeatingRange = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Repeating Range: " + s);
                }
            }
            s = GetStringParameter("RightMargin");
            if (s != null)
            {
                try
                {
                    toolkitArgs.RightMargin = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Right Margin: " + s);
                }
            }
            else
            {
                toolkitArgs.RightMargin = 5;
            }
            s = GetStringParameter("RowHeight");
            if (s != null)
            {
                try
                {
                    toolkitArgs.RowHeight = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Row Height: " + s);
                }
            }

            s = GetStringParameter("Source");
            if (s != null)
            {
                toolkitArgs.Source = Path.GetFullPath(s);
            }
            else
            {
                Console.WriteLine("Sorry the Source parameter is empty, please provide a valid source ");
                Usage();
            }

            s = GetStringParameter("Bookmarks");
            if (s != null)
            {
                toolkitArgs.Bookmarks = s;
            }

            s = GetStringParameter("Attachments");
            if (s != null)
            {
                toolkitArgs.Attachments = s;
            }

            s = GetStringParameter("SourceType");
            if (s != null)
            {
                toolkitArgs.SourceType = s;
            }
            else
            {
                Console.WriteLine("Source type not given, setting to it to file.");
                toolkitArgs.SourceType = "file";
            }
            s = GetStringParameter("SplitRange");
            if (s != null)
            {
                toolkitArgs.SplitRange = s;
            }
            s = GetStringParameter("StampColor");
            if (s != null)
            {
                toolkitArgs.StampColor = s;
            }
            s = GetStringParameter("StampObject");
            if (s != null)
            {
                toolkitArgs.StampObject = s;
            }
            s = GetStringParameter("StampPrefix");
            if (s != null)
            {
                toolkitArgs.StampPrefix = s;
            }
            s = GetStringParameter("StampSuffix");
            if (s != null)
            {
                toolkitArgs.StampSuffix = s;
            }
            s = GetStringParameter("StampText");
            if (s != null)
            {
                toolkitArgs.StampText = s;
            }

            s = GetStringParameter("StartPage");
            if (s != null)
            {
                try
                {
                    toolkitArgs.StartPage = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Start Page: " + s);
                }
            }
            s = GetStringParameter("TargetFolder");
            if (s != null)
            {
                toolkitArgs.TargetFolder = Path.GetFullPath(s + @"\");
            }
            else
            {
                Console.WriteLine("Sorry the TargetFolder parameter is empty, please provide a valid Target. ");
                Usage();
            }
            s = GetStringParameter("TopMargin");
            if (s != null)
            {
                try
                {
                    toolkitArgs.TopMargin = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Top Margin: " + s);
                }
            }
            else
            {
                toolkitArgs.TopMargin = 5;
            }
            s = GetStringParameter("Width");
            if (s != null)
            {
                try
                {
                    toolkitArgs.Width = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("Width: " + s);
                }
            }
            s = GetStringParameter("XCoord");
            if (s != null)
            {
                try
                {
                    toolkitArgs.XCoord = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("XCoord: " + s);
                }
            }
            s = GetStringParameter("YCoord");
            if (s != null)
            {
                try
                {
                    toolkitArgs.YCoord = System.Convert.ToInt32(s);
                }
                catch (Exception)
                {
                    Console.WriteLine("YCoord: " + s);
                }
            }
        }

        private static string GetStringParameter(string ParameterName)
        {
            string Parameter = null;
            try
            {
                if (CommandLine[ParameterName] != null)
                    Parameter = CommandLine[ParameterName];
            }
            catch (Exception ex)
            {
                Environment.Exit(1);
                Console.WriteLine("Failed To GetStringParameter : " + ex.Message);
            }
            return (Parameter);
        }

        private static void ValidateCommmand()
        {
            int errors = 0;
            ValidOperations = new List<string> { "StampTextAsString", "StampPageNumber", "StampPageNumberBates", "StampVariable", "StampPDFImage", "StampPDFText",
                                                "CSVToPDF","OfficeWord","OfficeExcel","OfficePub","OfficePower","ConvertToPDFA","InsertAttachment",
                                                "InsertBookmarks","AddMetadata","AddPermission","AddXMP","AddOpenSettings", "SplitPageRange","SplitBookmark","SplitNormal",
                                                   "ExtarctImages","ImageToPDF","ExtractTextHocr","ExtractText","mergepdf","MergeImagesToPDF","Overlay"};

            if (!ValidOperations.Contains(toolkitArgs.Operation, StringComparer.OrdinalIgnoreCase))
            {
                Console.WriteLine("Sorry {0} is not a valid operation.", toolkitArgs.Operation);
                errors++;
            }
            switch (toolkitArgs.SourceType.ToLower())
            {
                case "file":
                    {
                        if (!File.Exists(toolkitArgs.Source))
                        {
                            Console.WriteLine("Sorry the source file {0} does not exist, \nif you want to use directories, set SourceType=folder or tree.", toolkitArgs.Source);
                            errors++;
                        }
                    }
                    break;

                default:
                    {
                        if (!Directory.Exists(toolkitArgs.Source))
                        {
                            Console.WriteLine("Sorry the source folder {0} does not exist, \nif you want to use a file, set SourceType=file.", toolkitArgs.Source);
                            errors++;
                        }
                    }
                    break;
            }

            if (!(Directory.Exists(toolkitArgs.TargetFolder)))
            {
                if (toolkitArgs.CreateFolders)
                {
                    try
                    {
                        Directory.CreateDirectory(toolkitArgs.TargetFolder);
                    }
                    catch
                    {
                        Console.WriteLine("Sorry Could not create target directory {0}\n, make sure your have write permissions to the location and the path is valid.", toolkitArgs.TargetFolder);
                        errors++;
                    }
                }
                else
                {
                    Console.WriteLine("Sorry the target folder {0} does not exist, create the directory first or set the CreateFolders parameter to true.", toolkitArgs.TargetFolder);
                    errors++;
                }
            }

            if (errors > 0)
            {
                Usage();
            }
            if (string.IsNullOrEmpty(toolkitArgs.OutputFile))
            {
                toolkitArgs.OutputFile = string.Empty;
            }
            originalOutPut = toolkitArgs.OutputFile.ToString();
        }

        private static void ProcessFile(string fileName)
        {
            toolkitArgs.OutputFile = ReplaceIgnoreCase(originalOutPut, "%filename", Path.GetFileNameWithoutExtension(fileName));
            if (toolkitArgs.Operation.ToLower().StartsWith("split"))
            {
                SplitMergePDFHandler.ProcessFile(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower().StartsWith("stamp"))
            {
                StampPDFHandler.ProcessFile(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower().Contains("image"))
            {
                ImageHandler.ProcessFile(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower().StartsWith("office"))
            {
                OfficeConversions.ProcessFile(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower().StartsWith("insert"))
            {
                BookmarksAttachments.ProcessFile(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower().StartsWith("add"))
            {
                SecurityMetadataHandler.ProcessFile(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower().StartsWith("extracttext"))
            {
                ExtractText.ProcessFile(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower() == "converttopdfa")
            {
                CSVPDFA.ConvertToPDFA(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower() == "csvtopdf")
            {
                CSVPDFA.ProcessFile(fileName, toolkitArgs);
            }
            else if (toolkitArgs.Operation.ToLower() == "overlay")
            {
                Overlay.ProcessFile(fileName, toolkitArgs);
            }
            else
            {
                Console.WriteLine("{0} Is not a valid operation", toolkitArgs.Operation);
                Usage();
            }
        }

        private static void ProcessSource()
        {
            if (toolkitArgs.Operation.ToLower().StartsWith("merge"))
            {
                SplitMergePDFHandler.ProcessSource(toolkitArgs);
                return;
            }
            switch (toolkitArgs.SourceType.ToLower())
            {
                case "file":
                    {
                        if (File.Exists(toolkitArgs.Source))
                        {
                            ProcessFile(toolkitArgs.Source);
                        }
                        else
                        {
                            Console.WriteLine("Sorry the source file {0} does not exist.", toolkitArgs.Source);
                            Usage();
                        }
                    }
                    break;

                case "folder":
                    {
                        if (Directory.Exists(toolkitArgs.Source))
                        {
                            var files = Directory.GetFiles(toolkitArgs.Source, "*.*", SearchOption.TopDirectoryOnly);
                            foreach (var file in files)
                            {
                                ProcessFile(file);
                            }
                        }
                        else
                        {
                            Console.WriteLine("Sorry the source folder {0} does not exist.", toolkitArgs.Source);
                            Usage();
                        }
                    }
                    break;

                case "tree":
                    {
                        if (Directory.Exists(toolkitArgs.Source))
                        {
                            var files = Directory.GetFiles(toolkitArgs.Source, "*.*", SearchOption.AllDirectories);
                            foreach (var file in files)
                            {
                                ProcessFile(file);
                            }
                        }
                        else
                        {
                            Console.WriteLine("Sorry the source folder {0} does not exist.", toolkitArgs.Source);
                            Usage();
                        }
                    }
                    break;
            }
        }

        private static string GetLicenseKey()
        {
            string key;
            try
            {
                using (StreamReader reader = new StreamReader("license.txt"))
                {
                    key = reader.ReadToEnd();
                }
            }
            catch (Exception)
            {
                return string.Empty;
            }
            return key.Trim();
        }

        private static void Usage()
        {
            var inputArgs = new List<string>() {
           "/Operation =  (StampTextAsString,StampPageNumber,StampPageNumberBates,StampVariable,StampPDFImage,StampPDFText .... check reference guide for rest)",
        "/Source = (Source File, Folder or Tree)",
        "/SourceType =(file,folder,tree)",
        "/StampText =",
        "/StampPrefix =",
        "/StampColor =",
        "/StampSuffix =",
        "/Permissions =",
        "/Metadata =",
        "/OpenSettings =",
        "/SplitRange =",
        "/RepeatingRange =",
        "/StampObject = Stamp Image Path or Stamp Variable",
        "/TargetFolder =",
        "/OutputFile =",
        "/Password =",
        "/StartPage =",
        "/PageNumber =",
        "/EndPage =",
        "/Opacity =",
        "/FontSize =",
        "/LeftMargin =",
        "/RightMargin =",
        "/TopMargin =",
        "/BottomMargin =",
        "/RowHeight =",
        "/CellMargin =",
        "/XCoord =",
        "/YCoord =",
        "/Length =",
        "/Width =",
        "/BateLength =",
        "/Overlay =",
        "/Font =",
        "/OnErrorContinue =",
        "/Pdfa =",
            };
            foreach (var line in inputArgs)
            {
                Console.WriteLine(line);
            }
            Environment.Exit(1);
        }
    }
}