﻿using Aquaforest.PDF;
using System;

namespace SetAndGetPDFMetadata
{
    internal class SetGetMetadata
    {
        private static void Main(string[] args)
        {
            //Assign Licence Key
            PDFToolkit.LicenseKey = "MD1TdGFuZGFyZCBEZXZlbG9wZXI7MT10cmlhbDsyPTUyNDc3NzQ2NTM5ODM5Mjc4ODk7Mz10cmlhbDs0PTE7NT1UcnVlOzUuMT1GYWxzZTsxMD0xNDs4PTE1RTgzRUY4NkY4QkI4N0I5MjBDN0IwMDQxN0M2RDY5RTQ2NDlGRTUzNDE1MUYwQTg0MjQ2NzhEMDUyNEY5Q0U7OT0yLjEuMC4w";
            string inputFile = @"..\documents\source\releasenotes.pdf";
            string outputFile = @"..\documents\output\metadata.pdf";
            PDFDocumentInformation info = new PDFDocumentInformation()
            {
                Author = "Name Surname",
                Subject = "Test",
                Title = "New PDF",
                Keywords = "PDF, OCR, SDK",
                CreationDate = new DateTime(2013, 9, 9),
                Producer = "Aquaforest"
            };
            info.SetCustomMetadataValue("AQUAFOREST_PDF_TOOLKIT", "1.01");
            SetPDFMetadata(inputFile, outputFile, info);

            ReadDocumentInformation(outputFile);
        }

        public static void ReadDocumentInformation(string input)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                PDFDocumentInformation docInfo = doc.GetDocumentInformation();
                Console.WriteLine("Author = {0}, CreationDate = {1}, Creator = {2} .", docInfo.Author, docInfo.CreationDate, docInfo.Creator);
                doc.Close();
            }
            catch (Exception)
            {
            }
        }

        public static void SetPDFMetadata(string input, string output, PDFDocumentInformation metadata)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                doc.SetDocumentInformation(metadata);
                doc.Save(output);
                doc.Close();
            }
            catch (Exception)
            {
            }
        }
    }
}