﻿using Aquaforest.PDF;
using System;

namespace SetPDFPermissions
{
    internal class SetGetPermission
    {
        private static void Main(string[] args)
        {
            //Assign Licence Key
            PDFToolkit.LicenseKey = "MD1TdGFuZGFyZCBEZXZlbG9wZXI7MT10cmlhbDsyPTUyNDc3NzQ2NTM5ODM5Mjc4ODk7Mz10cmlhbDs0PTE7NT1UcnVlOzUuMT1GYWxzZTsxMD0xNDs4PTE1RTgzRUY4NkY4QkI4N0I5MjBDN0IwMDQxN0M2RDY5RTQ2NDlGRTUzNDE1MUYwQTg0MjQ2NzhEMDUyNEY5Q0U7OT0yLjEuMC4w";
            string inputFile = @"..\documents\source\releasenotes.pdf";
            string outputFile = @"..\documents\output\security.pdf";
            PDFPermission permission = new PDFPermission()
            {
                AllowExtractContents = false,
                AllowModifyContents = false,
                AllowAssembly = true,
                AllowDegradedPrinting = true,
                AllowExtractForAccessibility = true,
                AllowFillInForm = false,
                AllowModifyAnnotations = false,
                AllowPrinting = true
            };

            PDFSecurity encryptor = new PDFSecurity()
            {
                Permission = permission,
                OwnerPassword = "myPassword",
                UserPassword = "myPassword"
            };

            SetSecurity(inputFile, outputFile, encryptor);

            ReadPDFSecurity(outputFile, "myPassword");
        }

        public static void ReadPDFSecurity(string input, string password)
        {
            PDFDocument doc = null;
            try
            {
                doc = new PDFDocument(input);
            }
            catch (Exception ex)
            {
                if (ex.Message == "Cannot decrypt PDF, the password is incorrect")
                {
                    doc = new PDFDocument(input, password);
                }
                else
                {
                    Console.WriteLine("Cannot Open PDF");
                }
            }
            PDFSecurity encryptor = new PDFSecurity();
            PDFPermission pdfPermissions = encryptor.ReadPDFSecurity(doc);
            Console.WriteLine("AllowAssembly = {0}, AllowModifyContents = {1},AllowDegradedPrinting = {2}, AllowExtractContents = {3},AllowExtractForAccessibility = {4}, AllowFillInForm = {5},AllowModifyAnnotations = {6}, AllowModifyContents = {7}, AllowPrinting = {8}.",
            pdfPermissions.AllowAssembly, pdfPermissions.AllowModifyContents, pdfPermissions.AllowDegradedPrinting, pdfPermissions.AllowExtractContents, pdfPermissions.AllowExtractForAccessibility, pdfPermissions.AllowFillInForm, pdfPermissions.AllowModifyAnnotations, pdfPermissions.AllowModifyContents, pdfPermissions.AllowPrinting);
        }

        public static void SetSecurity(string input, string output, PDFSecurity security)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                security.SecurePDF(doc, output);
            }
            catch (Exception)
            {
            }
        }
    }
}