﻿using Aquaforest.PDF;
using System;
using System.Drawing;
using System.IO;

namespace StampPDF
{
    internal class StampPDF
    {
        private static void Main(string[] args)
        {
            //Assign Licence Key
            PDFToolkit.LicenseKey = "MD1TdGFuZGFyZCBEZXZlbG9wZXI7MT10cmlhbDsyPTUyNDc3NzQ2NTM5ODM5Mjc4ODk7Mz10cmlhbDs0PTE7NT1UcnVlOzUuMT1GYWxzZTsxMD0xNDs4PTE1RTgzRUY4NkY4QkI4N0I5MjBDN0IwMDQxN0M2RDY5RTQ2NDlGRTUzNDE1MUYwQTg0MjQ2NzhEMDUyNEY5Q0U7OT0yLjEuMC4w";
            string inputFile = @"..\documents\source\image_pdf.pdf";
            string outputPath = @"..\documents\output\stamp\";
            string stampFile = @"..\documents\source\stampFile.png";
            if (!Directory.Exists(outputPath))
            {
                Directory.CreateDirectory(outputPath);
            }
            StampPDFTextAsText(inputFile, outputPath + "stampText.pdf", PDFStamperPositions.CenterRight, "PDF Toolkit Stamp");
            StampPDFImage(inputFile, outputPath + "stampimage.pdf", PDFStamperPositions.BottomCenter, stampFile);
            StampPDFBates(inputFile, outputPath + "stampbates.pdf", PDFStamperPositions.Center, "aqua", "pdf");
            StampPDFImageWithCoordinates(inputFile, outputPath + "stampcoords.pdf", 20, 20, stampFile);
            StampPDFTextAsImage(inputFile, outputPath + "stampTextAsimage.pdf", PDFStamperPositions.TopRight, "PDF Toolkit Stamp");

            StampVariable(inputFile, outputPath + "stampvar.pdf", PDFStamperPositions.BottomLeft, "%G", 2);
        }

        public static void StampPDFImage(string input, string output, PDFStamperPositions position, string imagePath)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                PDFStamper stamper = new PDFStamper(doc, output);
                stamper.StampOpacity = 20;
                stamper.StampColor = Color.Black;
                stamper.StampPDFImage(imagePath, position);
            }
            catch (Exception)
            {
            }
        }

        public static void StampPDFTextAsImage(string input, string output, PDFStamperPositions position, string text)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                PDFStamper stamper = new PDFStamper(doc, output);
                stamper.FontSize = 12;
                stamper.StampOpacity = 50;
                stamper.StampColor = Color.Black;
                stamper.StampPDFTextAsImage(text, position);
            }
            catch (Exception)
            {
            }
        }

        public static void StampPDFTextAsText(string input, string output, PDFStamperPositions position, string text)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                PDFStamper stamper = new PDFStamper(doc, output);
                stamper.FontSize = 12;
                stamper.StampOpacity = 100;
                stamper.StampColor = Color.Black;
                stamper.StampTextAsString(text, position);
            }
            catch (Exception)
            {
            }
        }

        public static void StampVariable(string input, string output, PDFStamperPositions position, string variable, int page)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                PDFStamper stamper = new PDFStamper(doc, output);
                stamper.FontSize = 12;
                stamper.StampOpacity = 40;
                stamper.StampColor = Color.Black;
                stamper.StampVariable(variable, position, page);
            }
            catch (Exception)
            {
            }
        }

        public static void StampPDFBates(string input, string output, PDFStamperPositions position, string suffix, string prefix)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                PDFStamper stamper = new PDFStamper(doc, output);
                stamper.FontSize = 12;
                stamper.StampOpacity = 90;
                stamper.StampColor = Color.Black;
                stamper.StampPageNumberBates(7, suffix, prefix, 1, 1, position);
            }
            catch (Exception)
            {
            }
        }

        public static void StampPDFImageWithCoordinates(string input, string output, int x, int y, string imagePath)
        {
            try
            {
                PDFDocument doc = new PDFDocument(input);
                PDFStamper stamper = new PDFStamper(doc, output);
                stamper.FontSize = 12;
                stamper.StampOpacity = 60;
                stamper.StampColor = Color.Black;
                stamper.StampPDFImage(imagePath, x, y);
            }
            catch (Exception)
            {
            }
        }
    }
}